import ctypes as ctypes
import time as xtime
from x2canlibrary import *

COMPORT = 5
# Init Triple structure
USB2CAN_triple_adapter = ctypes.POINTER(ctypes.c_void_p)()

#rychlosti a flagy
USB2CAN_triple_adapter = usb2can_lib.USB2CAN_TRIPLE_PrepareAdapter(COMPORT)
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC1(
    USB2CAN_triple_adapter, SPEED_250k, False)
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC2(
    USB2CAN_triple_adapter, SPEED_250k, False)
usb2can_lib.USB2CAN_TRIPLE_PrepareAdapterSpeedC3(
    USB2CAN_triple_adapter, CAN_250K_1M, False, False, False)

usb2can_lib.USB2CAN_TRIPLE_SelectActualAdapter(USB2CAN_triple_adapter)

usb2can_lib.USB2CAN_TRIPLE_SetTimeStampMode(False)

usb2can_lib.USB2CAN_TRIPLE_SetBufferMode(1)


null_ptr = ctypes.POINTER(ctypes.c_void_p)()
print(usb2can_lib.USB2CAN_TRIPLE_Open(SPEED_250k, null_ptr))
# usb2can_lib.X2CAN_USB2CAN_TRIPLE_SetPointers()

message = CAN_MESSAGE()
time = CANMessageTime()
time.Hour = 1
time.Minute = 1
time.Second = 1
time.Milliseconds = 1
time.TimeStampUS = 1

message.Id = 0x11
message.st_ext = False
message.fd_can = False
message.port = 2
message.dont_delete = False
message.Id1 = 0x18
message.Id2 = 0x13
message.fd_br_switch = False
message.fd_data = ctypes.POINTER(ctypes.c_ubyte)()
message.fd_esi = False
message.fd_sid11 = False
message.rtr = False
message.length = 8
message.time = CANMessageTime()
message.data[0] = 1
message.data[1] = 2
message.data[2] = 3
message.data[3] = 4
message.data[4] = 5
message.data[5] = 6
message.data[6] = 7
message.data[7] = 255

usb2can_lib.USB2CAN_TRIPLE_SendCANMessage(message)

print("waiting for message")

message1 = usb2can_lib.X2CAN_PrepareMessage()
timeout = 1000
while True:
    if usb2can_lib.USB2CAN_TRIPLE_WaitForRxMessage(timeout):
        if(usb2can_lib.USB2CAN_TRIPLE_GetCANMessage(message1)):
            print("-------------------------")
            print("StandardId", end=" ")
            print(usb2can_lib.X2CAN_GetStandardId(message1))
            print("ExtendedId", end=" ")
            print(usb2can_lib.X2CAN_GetExtendedId(message1))
            print("CAN FD :", end=" ")
            print(usb2can_lib.X2CAN_IsFD(message1))
            print("Port", end=" ")
            print(usb2can_lib.X2CAN_GetPort(message1))
            print("data length", end=" ")
            data_length = usb2can_lib.X2CAN_GetLength(message1)
            print(data_length)
            print("data", end=" ")
            for x in range(data_length):
                data = usb2can_lib.X2CAN_GetData(message1, x)
                if(data == 255 and x == data_length-1):
                    print(data, end =", ")
                    exit()
                print(data, end =", ")

            print("")

        else:
            print("no message recieved within : ")

usb2can_lib.USB2CAN_TRIPLE_Close()
    